import { Cue } from './cues';
import { SelectorPart } from './types';
declare type CueGroup = {
    cues: Cue[];
    penalty: number;
    selectorParts: SelectorPart[];
    valueLength: number;
};
/**
 * Build the cue sets.
 * There are multiple since each level of cues
 * can only have one type per level (css/text).
 */
export declare const buildCueSets: (cues: Cue[]) => Cue[][];
/**
 * Build all combinations of items with the specified size.
 */
export declare const combine: <T>(items: T[], size: number) => T[][];
export declare const sortCues: (cues: Cue[]) => Cue[];
export declare const trimExcessCues: (cuesToTrim: Cue[], target: HTMLElement, goalSize: number) => CueGroup | null;
export declare const findBestCueGroup: (seedGroup: CueGroup, target: HTMLElement, maxSize: number) => CueGroup;
export declare const optimizeCues: (cues: Cue[], target: HTMLElement) => CueGroup | null;
export {};
